﻿using System.Drawing;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class DottedBoxLabel : Control
    {
        public DottedBoxLabel()
        {
            InitializeComponent();
        }

        protected override void OnPaint(PaintEventArgs pe)
        {
            base.OnPaint(pe);

            Rectangle rectArea = this.ClientRectangle;
            rectArea.Inflate(-1, -1);

            using (Pen dottedPen = new Pen(Brushes.Black, 1))
            {
                dottedPen.DashStyle = System.Drawing.Drawing2D.DashStyle.Dot;
                pe.Graphics.DrawRectangle(dottedPen, rectArea);
            }

            using (Font normalFont = new Font(FontFamily.GenericSansSerif, 10))
            {
                SizeF outputSize = pe.Graphics.MeasureString(this.Text, normalFont);

                PointF pt = new PointF();
                pt.X = (rectArea.Width - outputSize.Width) / 2;
                pt.Y = (rectArea.Height - outputSize.Height) / 2;
                pe.Graphics.DrawString(this.Text, normalFont, Brushes.Black, pt);
            }
        }
    }
}
